#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
    /// </summary>
    [Description("Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)")]
    public class AARCBigBenda : Indicator
    {
        #region Variables
        // Wizard generated variables
			
            private int countback = 12; // Default setting for Countback
            private double countbackoffset = 0; // Default setting for Countbackoffset
			private bool divergenceon = true;
            private int fTPeriod = 10; // Default setting for FTPeriod
			private int seperation = 30; // Default setting for TimeFrame
			private int timeFrame = 60; // Default setting for other Time Frame
			private bool thistimeperiodon = true; // Default setting for the current chart time period on
			private bool texton = true;
			private string textbb = @"BigBenda"; // Default setting for BigBendatext to plot on chart
            private double zerooffset = 0; // Default setting for Zerooffset
		
			private Color zupdotcolor = Color.MediumOrchid; // Default setting for Upcolor
			private Color zdowndotcolor = Color.MediumBlue; // Default setting for Upcolor
		
			private bool zzstrategyuse = false;
		
			private int zerolinecross = 1; // Default setting for other Time Frame
				
		
				
        
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            VendorLicense("RaefonTrading", "AARCBigBenda", "raefontrading.com", "info@raefontrading.com");
			if (thistimeperiodon == false)			{			Add(PeriodType.Minute, timeFrame);			}
            Overlay				= true;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			
			
            // Use this method for calculating your indicator values. Assign a value to each
            
			if (zzstrategyuse == true){Value.Set(0);}
			if (CurrentBar < (countback*2))				return; 
			if (CurrentBar < (fTPeriod*2))				return; 
			
			
			if (thistimeperiodon == false)
			{
				if (BarsInProgress == 1)
				{
			if (divergenceon == true)		
				{// other time frame sell signal with divergence
				if (FisherTransform(FTPeriod)[0]  - Countbackoffset * TickSize <= DonchianChannel(FisherTransform(FTPeriod), Countback).Upper[2]
                && DonchianChannel(FisherTransform(FTPeriod), Countback).Lower[0] >= (0 - Zerooffset )
				&& FisherTransform(FTPeriod)[1] >= FisherTransform(FTPeriod)[2]
				&& FisherTransform(FTPeriod)[0] < FisherTransform(FTPeriod)[1]
				&&  FisherTransform(FTPeriod)[0] > 0)	
            		{						
						DrawDot("My dot" + CurrentBar, false, 1, High[0] +  seperation * TickSize, zdowndotcolor);
							if (texton == true){DrawText("BigBendadot"+ CurrentBar, textbb, 0, High[0] + (seperation+10) *TickSize, Color.Black);}
							
							if (zzstrategyuse == true){Value.Set(32);}
            		}
				// other time frame buy signal with divergence
				if (FisherTransform(FTPeriod)[0] +  Countbackoffset * TickSize >= DonchianChannel(FisherTransform(FTPeriod), Countback).Lower[2]
                && DonchianChannel(FisherTransform(FTPeriod), Countback).Upper[0]  <= (0 + Zerooffset)
				&& FisherTransform(FTPeriod)[1] <= FisherTransform(FTPeriod)[2]
				&& FisherTransform(FTPeriod)[0] > FisherTransform(FTPeriod)[1]
					&&  FisherTransform(FTPeriod)[0] < 0)	
            		{
						DrawDot("My dot" + CurrentBar, false, 1, Low[0] + - seperation * TickSize, zupdotcolor);
							if (texton == true){DrawText("BigBendadot"+ CurrentBar, textbb, 0, Low[0] + -(seperation+10) *TickSize, Color.Black);}
						
							if (zzstrategyuse == true){Value.Set(31);}
            		}	
					
				}
				// other time frame signal with NO divergence
				if (divergenceon == false)
				{
					// other time frame sell signal NO divergence
				if (FisherTransform(FTPeriod)[1] >= FisherTransform(FTPeriod)[2]
					&& FisherTransform(FTPeriod)[0] < FisherTransform(FTPeriod)[1]
					&&  FisherTransform(FTPeriod)[0] > 0)	
            		{						
						DrawDot("My dot" + CurrentBar, false, 1, High[0] +  seperation * TickSize, zdowndotcolor);
							if (texton == true){DrawText("BigBendadot"+ CurrentBar, textbb, 0, High[0] + (seperation+10) *TickSize, Color.Black);}
							
							if (zzstrategyuse == true){Value.Set(12);}
            		}
				// other time frame buy signal	NO divergence				
										
								
					if (FisherTransform(FTPeriod)[1] <= FisherTransform(FTPeriod)[2]
						&& FisherTransform(FTPeriod)[0] > FisherTransform(FTPeriod)[1]
						&& FisherTransform(FTPeriod)[0] < 0)	
            		{
						DrawDot("My dot" + CurrentBar, false, 1, Low[0]  + - seperation * TickSize, zupdotcolor);
							if (texton == true){DrawText("BigBendadot"+ CurrentBar, textbb, 0, Low[0] + -(seperation+10) *TickSize, Color.Black);}
						
							if (zzstrategyuse == true){Value.Set(11);}
            		}	
				}
				
				
				}
			}
			
			if (thistimeperiodon == true)
			{
			if (divergenceon == true)	
				{// this time frame sell signal with divergence
				if (FisherTransform(FTPeriod)[0] - Countbackoffset  <= DonchianChannel(FisherTransform(FTPeriod), Countback).Upper[2]
                && DonchianChannel(FisherTransform(FTPeriod), Countback).Lower[0] >= (0 - Zerooffset )
				&& FisherTransform(FTPeriod)[1] >= FisherTransform(FTPeriod)[2]
				&& FisherTransform(FTPeriod)[0] < FisherTransform(FTPeriod)[1]
					&&  FisherTransform(FTPeriod)[0] > 0)	
            		{						
						DrawDot("My dot" + CurrentBar, false, 1, High[0] +  seperation * TickSize, zdowndotcolor);
							if (texton == true){DrawText("BigBendadot"+ CurrentBar, textbb, 0, High[0] + (seperation+10) *TickSize, Color.Black);}
							
							if (zzstrategyuse == true){Value.Set(22);}
            		}
				// this time frame buy signal with divergence
				if (FisherTransform(FTPeriod)[0] +  Countbackoffset  >= DonchianChannel(FisherTransform(FTPeriod), Countback).Lower[2]
                && DonchianChannel(FisherTransform(FTPeriod), Countback).Upper[0]  <= (0 + Zerooffset)
				&& FisherTransform(FTPeriod)[1] <= FisherTransform(FTPeriod)[2]
				&& FisherTransform(FTPeriod)[0] > FisherTransform(FTPeriod)[1]
					&&  FisherTransform(FTPeriod)[0] < 0)	
            		{
						DrawDot("My dot" + CurrentBar, false, 1, Low[0]   - seperation * TickSize, zupdotcolor);
							if (texton == true){DrawText("BigBendadot"+ CurrentBar, textbb, 0, Low[0] + -(seperation+10) *TickSize, Color.Black);}
						
							if (zzstrategyuse == true){Value.Set(21);}
            		}	
					
								
			}
				if (divergenceon == false)
				{
					// this time frame sell signal NO divergence
				if (FisherTransform(FTPeriod)[1] >= FisherTransform(FTPeriod)[2]
					&& FisherTransform(FTPeriod)[0] < FisherTransform(FTPeriod)[1]
					&&  FisherTransform(FTPeriod)[0] > 0)	
            		{						
						DrawDot("My dot" + CurrentBar, false, 1, High[0] +  seperation * TickSize, zdowndotcolor);
							if (texton == true){DrawText("BigBendadot"+ CurrentBar, textbb, 0, High[0] + (seperation+10) *TickSize, Color.Black);}
							
							if (zzstrategyuse == true){Value.Set(12);}
            		}
				// this time frame buy signal	NO divergence				
										
								
					if (FisherTransform(FTPeriod)[1] <= FisherTransform(FTPeriod)[2]
						&& FisherTransform(FTPeriod)[0] > FisherTransform(FTPeriod)[1]
						&& FisherTransform(FTPeriod)[0] < 0)	
            		{
						DrawDot("My dot" + CurrentBar, false, 1, Low[0]  + - seperation * TickSize, zupdotcolor);
							if (texton == true){DrawText("BigBendadot"+ CurrentBar, textbb, 0, Low[0] + -(seperation+10) *TickSize, Color.Black);}
						
							if (zzstrategyuse == true){Value.Set(11);}
            		}	
				}
				
				
				
				
			}
			
			
        }

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Plot0
        {
            get { return Values[0]; }
        }

        [Description("Bars counted per cycle")]
        [GridCategory("Parameters")]
        public int Countback
        {
            get { return countback; }
            set { countback = Math.Max(1, value); }
        }

        [Description("Offset above below previous high or low.")]
        [GridCategory("Parameters")]
        public double Countbackoffset
        {
            get { return countbackoffset; }
            set { countbackoffset = Math.Max(-10, value); }
        }
		[Description("Shows Fisher Transform turning points with or without Divergence. ")]
        [GridCategory("Parameters")]
        public bool Divergenceon
        {
            get { return divergenceon; }
            set { divergenceon = value; }
        }

        [Description("Fisher Transform Period minimum value = 2")]
        [GridCategory("Parameters")]
        public int FTPeriod
        {
            get { return fTPeriod; }
            set { fTPeriod = Math.Max(2, value); }
        }
		
		[Description("How far above / below for markers")]
        [GridCategory("Parameters")]
        public int Seperation
        {
            get { return seperation; }
            set { seperation = Math.Max(1, value); }
        }
		[Description("What you want to see displayed as a label.")]
        [GridCategory("Parameters")]
        public string Textbb
        {
            get { return textbb; }
            set { textbb = value; }
        }
		[Description("Plot text with marker")]
        [GridCategory("Parameters")]
        public bool Texton
        {
            get { return texton; }
            set { texton = value; }
        }
		[Description("Time frame in minutes to use if not chart time period")]
        [GridCategory("Parameters")]
        public int TimeFrame
        {
            get { return timeFrame; }
            set { timeFrame = Math.Max(1, value); }
        }
		[Description("True = Current chart time period in use")]
        [GridCategory("Parameters")]
	    public bool Thistimeperiodon
        {
            get { return thistimeperiodon; }
            set { thistimeperiodon = value; }
        }
        [Description("Offset above below zero line to keep in cycle.")]
        [GridCategory("Parameters")]
        public double Zerooffset
        {
            get { return zerooffset; }
            set { zerooffset = Math.Max(-10.000, value); }
        }
		[Description("Colour of buy dots")]
        [Category("Visual")]
		[Gui.Design.DisplayName("UpColor")]
		[XmlIgnore()]	
        public Color Zupdotcolor
        {
            get { return zupdotcolor; }
            set { zupdotcolor = value; }
        }
		[Description("Colour of sell dots")]
        [Category("Visual")]
		[Gui.Design.DisplayName("DownColor")]
		[XmlIgnore()]	
        public Color Zdowndotcolor
        {
            get { return zdowndotcolor; }
            set { zdowndotcolor = value; }
        }
		[Description("Divon False Up11 Down12 / ThisTime Divon Up21 Down22 / OtherTimeDivon Up31 Down32")]
        [GridCategory("Parameters")]
        public bool Zzstrategyuse
        {
            get { return zzstrategyuse; }
            set { zzstrategyuse = value; }
        }
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private AARCBigBenda[] cacheAARCBigBenda = null;

        private static AARCBigBenda checkAARCBigBenda = new AARCBigBenda();

        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        public AARCBigBenda AARCBigBenda(int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            return AARCBigBenda(Input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        public AARCBigBenda AARCBigBenda(Data.IDataSeries input, int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            if (cacheAARCBigBenda != null)
                for (int idx = 0; idx < cacheAARCBigBenda.Length; idx++)
                    if (cacheAARCBigBenda[idx].Countback == countback && Math.Abs(cacheAARCBigBenda[idx].Countbackoffset - countbackoffset) <= double.Epsilon && cacheAARCBigBenda[idx].Divergenceon == divergenceon && cacheAARCBigBenda[idx].FTPeriod == fTPeriod && cacheAARCBigBenda[idx].Seperation == seperation && cacheAARCBigBenda[idx].Textbb == textbb && cacheAARCBigBenda[idx].Texton == texton && cacheAARCBigBenda[idx].Thistimeperiodon == thistimeperiodon && cacheAARCBigBenda[idx].TimeFrame == timeFrame && Math.Abs(cacheAARCBigBenda[idx].Zerooffset - zerooffset) <= double.Epsilon && cacheAARCBigBenda[idx].Zzstrategyuse == zzstrategyuse && cacheAARCBigBenda[idx].EqualsInput(input))
                        return cacheAARCBigBenda[idx];

            lock (checkAARCBigBenda)
            {
                checkAARCBigBenda.Countback = countback;
                countback = checkAARCBigBenda.Countback;
                checkAARCBigBenda.Countbackoffset = countbackoffset;
                countbackoffset = checkAARCBigBenda.Countbackoffset;
                checkAARCBigBenda.Divergenceon = divergenceon;
                divergenceon = checkAARCBigBenda.Divergenceon;
                checkAARCBigBenda.FTPeriod = fTPeriod;
                fTPeriod = checkAARCBigBenda.FTPeriod;
                checkAARCBigBenda.Seperation = seperation;
                seperation = checkAARCBigBenda.Seperation;
                checkAARCBigBenda.Textbb = textbb;
                textbb = checkAARCBigBenda.Textbb;
                checkAARCBigBenda.Texton = texton;
                texton = checkAARCBigBenda.Texton;
                checkAARCBigBenda.Thistimeperiodon = thistimeperiodon;
                thistimeperiodon = checkAARCBigBenda.Thistimeperiodon;
                checkAARCBigBenda.TimeFrame = timeFrame;
                timeFrame = checkAARCBigBenda.TimeFrame;
                checkAARCBigBenda.Zerooffset = zerooffset;
                zerooffset = checkAARCBigBenda.Zerooffset;
                checkAARCBigBenda.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkAARCBigBenda.Zzstrategyuse;

                if (cacheAARCBigBenda != null)
                    for (int idx = 0; idx < cacheAARCBigBenda.Length; idx++)
                        if (cacheAARCBigBenda[idx].Countback == countback && Math.Abs(cacheAARCBigBenda[idx].Countbackoffset - countbackoffset) <= double.Epsilon && cacheAARCBigBenda[idx].Divergenceon == divergenceon && cacheAARCBigBenda[idx].FTPeriod == fTPeriod && cacheAARCBigBenda[idx].Seperation == seperation && cacheAARCBigBenda[idx].Textbb == textbb && cacheAARCBigBenda[idx].Texton == texton && cacheAARCBigBenda[idx].Thistimeperiodon == thistimeperiodon && cacheAARCBigBenda[idx].TimeFrame == timeFrame && Math.Abs(cacheAARCBigBenda[idx].Zerooffset - zerooffset) <= double.Epsilon && cacheAARCBigBenda[idx].Zzstrategyuse == zzstrategyuse && cacheAARCBigBenda[idx].EqualsInput(input))
                            return cacheAARCBigBenda[idx];

                AARCBigBenda indicator = new AARCBigBenda();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Countback = countback;
                indicator.Countbackoffset = countbackoffset;
                indicator.Divergenceon = divergenceon;
                indicator.FTPeriod = fTPeriod;
                indicator.Seperation = seperation;
                indicator.Textbb = textbb;
                indicator.Texton = texton;
                indicator.Thistimeperiodon = thistimeperiodon;
                indicator.TimeFrame = timeFrame;
                indicator.Zerooffset = zerooffset;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                AARCBigBenda[] tmp = new AARCBigBenda[cacheAARCBigBenda == null ? 1 : cacheAARCBigBenda.Length + 1];
                if (cacheAARCBigBenda != null)
                    cacheAARCBigBenda.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAARCBigBenda = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCBigBenda AARCBigBenda(int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            return _indicator.AARCBigBenda(Input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCBigBenda AARCBigBenda(Data.IDataSeries input, int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            return _indicator.AARCBigBenda(input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCBigBenda AARCBigBenda(int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            return _indicator.AARCBigBenda(Input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }

        /// <summary>
        /// Triggering from the Fisher Transform. Showing reversals and divergance (lower highs or higher lows.)
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCBigBenda AARCBigBenda(Data.IDataSeries input, int countback, double countbackoffset, bool divergenceon, int fTPeriod, int seperation, string textbb, bool texton, bool thistimeperiodon, int timeFrame, double zerooffset, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AARCBigBenda(input, countback, countbackoffset, divergenceon, fTPeriod, seperation, textbb, texton, thistimeperiodon, timeFrame, zerooffset, zzstrategyuse);
        }
    }
}
#endregion
