#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Enter the description of your new custom indicator here
    /// </summary>
    [Description("Enter the description of your new custom indicator here")]
    public class AARCMacDiv : Indicator
    {
        //#region Variables
        // Wizard generated variables
            private int afast = 10; // Default setting for Fast  
            private int aslow = 20; // Default setting for Slow
			private int asmooth = 1; // Default setting for Slow
            private int timeFrame = 60; // Default setting for TimeFrame
			private int timmingzone = 20000; // Default setting for TimeFrame
			private Color timmingzonecolor = Color.Aqua; // Default setting for background color
			private int seperation = 50; // Default setting for TimeFrame
			private Color zupdotcolor = Color.Aqua; // Default setting for Upcolor
			private Color zdowndotcolor = Color.Aqua; // Default setting for Upcolor
			private int counter = 0; // Default setting for Fast
			private int directioncounter = 2; // Default setting for Fast
			private bool thistimeperiodon = true; // Default setting for thistimeperiodon
			private bool wordingon = true;
			private string macdtrigtext = @"MACDiv"; // Default setting for Voltrigtext
			private int macdCountback = 6; // Default setting for MacdCountback
			private bool zzstrategyuse = false;
			
		
        // User defined variables (add any user defined variables below)
        //#endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
			VendorLicense("RaefonTrading", "AARCMacDiv", "raefontrading.com", "info@raefontrading.com");
            if (thistimeperiodon == false)			{			Add(PeriodType.Minute, timeFrame);			}
            Overlay				= true;
			
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
			
        {	
			if (zzstrategyuse == true){Value.Set(0);}
           
            if (CurrentBar < (aslow*5))
				return; 
			if (BarsInProgress == 0) 
			{
			counter = counter +1 ;
				if (counter > timmingzone)
				{
				BackColor = timmingzonecolor;

				}
				else BackColor = Color.Empty;				
				}
					if (thistimeperiodon == false)
						{
						if (BarsInProgress == 1)
			
						{
						
						if (MACD(BarsArray[1], Afast, Aslow, asmooth).Avg[0] > DonchianChannel(MACD(BarsArray[1], Afast, Aslow, asmooth).Avg, MacdCountback).Lower[3]
						&& MACD(BarsArray[1], Afast, Aslow, asmooth).Avg[0] > MACD(BarsArray[1], Afast, Aslow, asmooth).Avg[1]
						&& MACD(BarsArray[1], Afast, Aslow, asmooth).Avg[1] <= MACD(BarsArray[1], Afast, Aslow, asmooth).Avg[2]
						&& DonchianChannel(MACD(BarsArray[1], Afast, Aslow, asmooth).Avg, MacdCountback).Upper[1] < 0
						&& MACD(BarsArray[1], Afast, Aslow, asmooth).Avg[1] < 0)
            			{                
						DrawDot("My dot" + CurrentBar, false, 1, Low[0] + - seperation * TickSize, zupdotcolor);
							if (wordingon == true){DrawText("MACDdot"+ CurrentBar, macdtrigtext, 0, Low[0] + -(seperation+5) *TickSize, Color.Black);}
						counter = 0;
						directioncounter = 1;
							if (zzstrategyuse == true){Value.Set(21);}
            			}
						
						if (MACD(BarsArray[1], Afast, Aslow, asmooth).Avg[0] < DonchianChannel(MACD(BarsArray[1], Afast, Aslow, asmooth).Avg, MacdCountback).Upper[3]
						&& MACD(BarsArray[1], Afast, Aslow, asmooth).Avg[0] < MACD(BarsArray[1], Afast, Aslow, asmooth).Avg[1]
						&& MACD(BarsArray[1], Afast, Aslow, asmooth).Avg[1] >= MACD(BarsArray[1], Afast, Aslow, asmooth).Avg[2]
						&& DonchianChannel(MACD(BarsArray[1], Afast, Aslow, asmooth).Avg, MacdCountback).Lower[1]>0
						&& MACD(BarsArray[1], Afast, Aslow, asmooth).Avg[1] > 0)
						{			
						DrawDot("My dot" + CurrentBar, false, 1, High[0] + seperation * TickSize, zdowndotcolor);
							if (wordingon == true){DrawText("MACDdot"+ CurrentBar, macdtrigtext, 0, High[0] + (seperation+5) *TickSize, Color.Black);}
						counter = 0;
						directioncounter = 3;	
							if (zzstrategyuse == true){Value.Set(22);}
           				}
						}
						}
					if (thistimeperiodon == true)
					{
						if (MACD( Afast, Aslow, asmooth).Avg[0] > DonchianChannel(MACD( Afast, Aslow, asmooth).Avg, MacdCountback).Lower[3]
						&& MACD( Afast, Aslow, asmooth).Avg[0] > MACD( Afast, Aslow, asmooth).Avg[1]
						&& MACD( Afast, Aslow, asmooth).Avg[1] <= MACD( Afast, Aslow, asmooth).Avg[2]
						&& DonchianChannel(MACD( Afast, Aslow, asmooth).Avg, MacdCountback).Upper[1] < 0
						&& MACD( Afast, Aslow, asmooth).Avg[1] < 0 )
            			{                
						DrawDot("My dot" + CurrentBar, false, 1, Low[0] + - seperation * TickSize, zupdotcolor);
							if (wordingon == true){DrawText("MACDdot"+ CurrentBar, macdtrigtext, 0, Low[0] + -(seperation+5) *TickSize, Color.Black);}
						counter = 0;
						directioncounter = 1;
							if (zzstrategyuse == true){Value.Set(11);}
            			}
			
						if (MACD( Afast, Aslow, asmooth).Avg[0] < DonchianChannel(MACD( Afast, Aslow,asmooth).Avg, MacdCountback).Upper[3]
						&& MACD( Afast, Aslow, asmooth).Avg[0] < MACD( Afast, Aslow, asmooth).Avg[1]
						&& MACD( Afast, Aslow,asmooth).Avg[1] >= MACD( Afast, Aslow, asmooth).Avg[2]
						&& DonchianChannel(MACD( Afast, Aslow, asmooth).Avg, MacdCountback).Lower[1]>0
						&& MACD( Afast, Aslow,asmooth).Avg[1] > 0)
						{			
						DrawDot("My dot" + CurrentBar, false, 1, High[0] + seperation * TickSize, zdowndotcolor);
							if (wordingon == true){DrawText("MACDdot"+ CurrentBar, macdtrigtext, 0, High[0] + (seperation+5) *TickSize, Color.Black);}
						counter = 0;
						directioncounter = 3;
							if (zzstrategyuse == true){Value.Set(12);}
           				}
						
					
					}
			
        }

        #region Properties
        
		
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Plot0
        {
            get { return Values[0]; }
        }
		
        [Description("MacD Fast period")]
        [GridCategory("Parameters")]
        public int Afast
        {
            get { return afast; }
            set { afast = Math.Max(1, value); }
        }

        [Description("MacD Slow Period")]
        [GridCategory("Parameters")]
        public int Aslow
        {
            get { return aslow; }
            set { aslow = Math.Max(1, value); }
        }
		[Description("MacD Smooth period")]
        [GridCategory("Parameters")]
        public int Asmooth
        {
            get { return asmooth; }
            set { asmooth = Math.Max(1, value); }
        }
		[Description("Pips above below hi / lo to plot text and marker")]
        [GridCategory("Parameters")]
        public int Seperation
        {
            get { return seperation; }
            set { seperation = Math.Max(1, value); }
        }

        [Description("If another time period to be used")]
        [GridCategory("Parameters")]
        public int TimeFrame
        {
            get { return timeFrame; }
            set { timeFrame = Math.Max(1, value); }
        }
		[Description("Counts out bars since last marker activated use a high number like 20000 to clear off screen")]
        [GridCategory("Parameters")]
        public int Timmingzone
        {
            get { return timmingzone; }
            set { timmingzone = Math.Max(1, value); }
        }
		[Description("Colour of background when timming zone reached")]
        [Category("Visual")]
		[Gui.Design.DisplayName("TimmingColor")]
		[XmlIgnore()]	
        public Color Timmingzonecolor
        {
            get { return timmingzonecolor; }
            set { timmingzonecolor = value; }
        }
		[Description("Marker colour for buy signal")]
        [Category("Visual")]
		[Gui.Design.DisplayName("UpColor")]
		[XmlIgnore()]	
        public Color Zupdotcolor
        {
            get { return zupdotcolor; }
            set { zupdotcolor = value; }
        }
		[Description("Marker colour for sell signal")]
        [Category("Visual")]
		[Gui.Design.DisplayName("DownColor")]
		[XmlIgnore()]	
        public Color Zdowndotcolor
        {
            get { return zdowndotcolor; }
            set { zdowndotcolor = value; }
        }
        [Description("True = current chart false = other time period")]
        [GridCategory("Parameters")]
        public bool Thistimeperiodon
        {
            get { return thistimeperiodon; }
            set { thistimeperiodon = value; }
        }
		[Description("What you want to see displayed as a label.")]
        [GridCategory("Parameters")]
        public string Macdtrigtext
        {
            get { return macdtrigtext; }
            set { macdtrigtext = value; }
        }
		[Description("Max bars back Macd makes first low for divergence cycle. ")]
        [GridCategory("Parameters")]
        public int MacdCountback
        {
            get { return macdCountback; }
            set { macdCountback = Math.Max(1, value); }
        }
		[Description("True = use within a strategy  this time period buy = 11 sell = 12 other time period 21 = buy 22 = sell")]
        [GridCategory("Parameters")]
        public bool Zzstrategyuse
        {
            get { return zzstrategyuse; }
            set { zzstrategyuse = value; }
        }
		[Description("True will display your textnames")]
        [GridCategory("Parameters")]
        public bool Wordingon
        {
            get { return wordingon; }
            set { wordingon = value; }
        }
		
        #endregion
	}   
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private AARCMacDiv[] cacheAARCMacDiv = null;

        private static AARCMacDiv checkAARCMacDiv = new AARCMacDiv();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public AARCMacDiv AARCMacDiv(int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            return AARCMacDiv(Input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public AARCMacDiv AARCMacDiv(Data.IDataSeries input, int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            if (cacheAARCMacDiv != null)
                for (int idx = 0; idx < cacheAARCMacDiv.Length; idx++)
                    if (cacheAARCMacDiv[idx].Afast == afast && cacheAARCMacDiv[idx].Aslow == aslow && cacheAARCMacDiv[idx].Asmooth == asmooth && cacheAARCMacDiv[idx].MacdCountback == macdCountback && cacheAARCMacDiv[idx].Macdtrigtext == macdtrigtext && cacheAARCMacDiv[idx].Seperation == seperation && cacheAARCMacDiv[idx].Thistimeperiodon == thistimeperiodon && cacheAARCMacDiv[idx].TimeFrame == timeFrame && cacheAARCMacDiv[idx].Timmingzone == timmingzone && cacheAARCMacDiv[idx].Wordingon == wordingon && cacheAARCMacDiv[idx].Zzstrategyuse == zzstrategyuse && cacheAARCMacDiv[idx].EqualsInput(input))
                        return cacheAARCMacDiv[idx];

            lock (checkAARCMacDiv)
            {
                checkAARCMacDiv.Afast = afast;
                afast = checkAARCMacDiv.Afast;
                checkAARCMacDiv.Aslow = aslow;
                aslow = checkAARCMacDiv.Aslow;
                checkAARCMacDiv.Asmooth = asmooth;
                asmooth = checkAARCMacDiv.Asmooth;
                checkAARCMacDiv.MacdCountback = macdCountback;
                macdCountback = checkAARCMacDiv.MacdCountback;
                checkAARCMacDiv.Macdtrigtext = macdtrigtext;
                macdtrigtext = checkAARCMacDiv.Macdtrigtext;
                checkAARCMacDiv.Seperation = seperation;
                seperation = checkAARCMacDiv.Seperation;
                checkAARCMacDiv.Thistimeperiodon = thistimeperiodon;
                thistimeperiodon = checkAARCMacDiv.Thistimeperiodon;
                checkAARCMacDiv.TimeFrame = timeFrame;
                timeFrame = checkAARCMacDiv.TimeFrame;
                checkAARCMacDiv.Timmingzone = timmingzone;
                timmingzone = checkAARCMacDiv.Timmingzone;
                checkAARCMacDiv.Wordingon = wordingon;
                wordingon = checkAARCMacDiv.Wordingon;
                checkAARCMacDiv.Zzstrategyuse = zzstrategyuse;
                zzstrategyuse = checkAARCMacDiv.Zzstrategyuse;

                if (cacheAARCMacDiv != null)
                    for (int idx = 0; idx < cacheAARCMacDiv.Length; idx++)
                        if (cacheAARCMacDiv[idx].Afast == afast && cacheAARCMacDiv[idx].Aslow == aslow && cacheAARCMacDiv[idx].Asmooth == asmooth && cacheAARCMacDiv[idx].MacdCountback == macdCountback && cacheAARCMacDiv[idx].Macdtrigtext == macdtrigtext && cacheAARCMacDiv[idx].Seperation == seperation && cacheAARCMacDiv[idx].Thistimeperiodon == thistimeperiodon && cacheAARCMacDiv[idx].TimeFrame == timeFrame && cacheAARCMacDiv[idx].Timmingzone == timmingzone && cacheAARCMacDiv[idx].Wordingon == wordingon && cacheAARCMacDiv[idx].Zzstrategyuse == zzstrategyuse && cacheAARCMacDiv[idx].EqualsInput(input))
                            return cacheAARCMacDiv[idx];

                AARCMacDiv indicator = new AARCMacDiv();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Afast = afast;
                indicator.Aslow = aslow;
                indicator.Asmooth = asmooth;
                indicator.MacdCountback = macdCountback;
                indicator.Macdtrigtext = macdtrigtext;
                indicator.Seperation = seperation;
                indicator.Thistimeperiodon = thistimeperiodon;
                indicator.TimeFrame = timeFrame;
                indicator.Timmingzone = timmingzone;
                indicator.Wordingon = wordingon;
                indicator.Zzstrategyuse = zzstrategyuse;
                Indicators.Add(indicator);
                indicator.SetUp();

                AARCMacDiv[] tmp = new AARCMacDiv[cacheAARCMacDiv == null ? 1 : cacheAARCMacDiv.Length + 1];
                if (cacheAARCMacDiv != null)
                    cacheAARCMacDiv.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAARCMacDiv = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCMacDiv AARCMacDiv(int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.AARCMacDiv(Input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCMacDiv AARCMacDiv(Data.IDataSeries input, int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.AARCMacDiv(input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AARCMacDiv AARCMacDiv(int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            return _indicator.AARCMacDiv(Input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.AARCMacDiv AARCMacDiv(Data.IDataSeries input, int afast, int aslow, int asmooth, int macdCountback, string macdtrigtext, int seperation, bool thistimeperiodon, int timeFrame, int timmingzone, bool wordingon, bool zzstrategyuse)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AARCMacDiv(input, afast, aslow, asmooth, macdCountback, macdtrigtext, seperation, thistimeperiodon, timeFrame, timmingzone, wordingon, zzstrategyuse);
        }
    }
}
#endregion
